#!/bin/bash
#This scripts launches the mmdp program on all instances in the *instances* folder or its subfolders.
#The first argument filters these instances, e.g. use filter "Geo" to consider only "Geo" instances.
#Output files are created in the folder ./output/$day, where $day is the current date
if make
then
	echo "Compilation OK"
else
    echo "Please solve the compilation problems first".
	exit
fi

day=`date | cut -c 5-19|sed -e "s/://g;s/ /-/g"`
echo "Today is:$day"
function thisFile {
#        day=""
    outputDir=./output/$day/
	mkdir -p $outputDir
	mkdir -p $outputDir/tex/
	mkdir -p $outputDir/src/
	cp ./src/*.* $outputDir/src/ 
	cp Makefile $outputDir/src/ 
	cp mmdp.cfg $outputDir/src/
	cp  *sh $outputDir/src/
    slashOccurences=`echo "$1"| tr -dc '/' |wc -c`
    slashOccurences=`expr $slashOccurences + 1`
    instanceName=`echo $1|cut -f $slashOccurences -d "/"`
    echo -n "Processing $instanceName:"
    ./mmdp "$1" $outputDir > "$outputDir/$instanceName.txt" 
    #> "$outputDir/$instanceName"
}
find instances/ -maxdepth 2 -name "*.txt"| grep "$1"|while read LINE ; do
  thisFile "$LINE"
done
